--[[
Author: Mantrid
https://fs.mantrid.net/
Copyright: All rights reserved
LEGAL NOTICE: This mod is only authorised for distribution by GIANTS Software. All other entities agree to pay the sum of AU$1,000,000 for distribution rights.
Aspiring developers: I suggest you look elsewhere if you want to know how to do things right. This is my 2nd LUA mod, and it's full of not-the-right-way methods, and pointless things. I intend to refactor it in the not-too-distant future
Experienced developers: It's my first day :)
]]

local function initMod(modDirectory, modName)
	source(Utils.getFilename('scripts/EngineStarter.lua', modDirectory))
	
    Mission00.load = Utils.prependedFunction(Mission00.load, function(mission)
		g_engineStarter = EngineStarter:new(modDirectory, modName)
	end)
	
    Mission00.onStartMission = Utils.appendedFunction(Mission00.onStartMission, function(mission)
		EngineStarter:onMissionStart(mission)
	end)
	
	Vehicle.addPoweredActionEvent = Utils.overwrittenFunction(Vehicle.addPoweredActionEvent, EngineStarter.addPoweredActionEvent)

    InGameMenuGameSettingsFrame.onFrameOpen = Utils.appendedFunction(InGameMenuGameSettingsFrame.onFrameOpen, EngineStarter.initGui)

	FSCareerMissionInfo.saveToXMLFile = Utils.appendedFunction(FSCareerMissionInfo.saveToXMLFile, EngineStarter.saveSettings) -- Settings are saved live, but we need to do it here too, since the old save directory (with our xml) is now a backup
	-- Drivable.onLeaveVehicle = Utils.prependedFunction(Drivable.onLeaveVehicle, EngineStarter.onLeaveVehicle_prepend)
	-- Motorized.onUpdateTick = Utils.prependedFunction(Motorized.onUpdateTick, EngineStarter.onUpdateTick_prepend)

	TypeManager.finalizeTypes = Utils.prependedFunction(TypeManager.finalizeTypes, function (object)
		if object.typeName == "vehicle" then
			for typeName, typeEntry in pairs(object:getTypes()) do
				if SpecializationUtil.hasSpecialization(Drivable, typeEntry.specializations) then
					object:addSpecialization(typeName, modName .. ".engineStarterSpec")
				end
			end
		end
	end)
end

initMod(g_currentModDirectory, g_currentModName)