﻿EngineStarterSpec = {
	specEntryName = string.format("spec_%s.engineStarterSpec", g_currentModName)
}

function EngineStarterSpec.prerequisitesPresent(specializations)
	return true
end

function EngineStarterSpec.registerEventListeners(vehicleType)
	SpecializationUtil.registerEventListener(vehicleType, "onLoad", EngineStarterSpec)
	SpecializationUtil.registerEventListener(vehicleType, "onEnterVehicle", EngineStarterSpec)
end

function EngineStarterSpec:onLoad(savegame)
	self.getIsPowered = Utils.overwrittenFunction(self.getIsPowered, function (self, superFunc)
		-- Trying to steer without the engine running?
		if self.spec_drivable.lastInputValues.axisSteer ~= 0 then
			if g_engineStarter.multiShared_Steerable == 2 then
				return true
			end
		end

		return superFunc(self)
	end)
end

function EngineStarterSpec:onEnterVehicle()
	-- Check that our functions haven't been overwritten

	-- We need our function at this level for specialisations to report correctly
	if not Vehicle.addPoweredActionEvent(EngineStarter, "validate") then
		Logging.info("EngineStarter: Vehicle.addPoweredActionEvent was not our own. Replacing it with our own. Other mods may not function correctly.")
		Vehicle.addPoweredActionEvent = Utils.overwrittenFunction(Vehicle.addPoweredActionEvent, EngineStarter.addPoweredActionEvent)
	end

	-- Make sure the local level hasn't been overwritten
	if not self.addPoweredActionEvent(EngineStarter, "validate") then
		Logging.info("EngineStarter: self.addPoweredActionEvent was not our own. Replacing it with our own. Other mods may not function correctly.")
		self.addPoweredActionEvent = Utils.overwrittenFunction(self.addPoweredActionEvent, EngineStarter.addPoweredActionEvent)
	end
end
